#ifndef COMPACT_INTERVAL_STABBING_H
#define	COMPACT_INTERVAL_STABBING_H

#include "interval_stabbing.h"
#include "static_bitsequence_brw32.h"
#include "tree_ff.h"
#include "../util/coordinates_encoding/coordinates_storage.h"
#include "../util/coordinates_encoding/encoder.h"

#define STACK_SIZE 2000000

class compact_interval_stabbing : public interval_stabbing {
  public:
	compact_interval_stabbing(interval *intervals, uint size, uint blockSize, char *encoder, int scaleFactor);
	~compact_interval_stabbing();
	int query(const double queryPoint, long *result, uint *resultSize);
	int queryMark(interval *queryInterval, long *result, uint *resultSize, uint *intersector);
	int queryReport(interval *queryInterval, long *result, uint *resultSize, uint *intersector);
	uint memoryUsage();

  private:
	CoordinatesStorage *coordsS;
	long *ids;
	static_bitsequence *mmc_rank;
	tree_ff *tree;
	uint *maxCoordPos;//position in coords of an interval (accessed in preorder)
	
	uint *nodesDeque;
	uint ndHead;

};

#endif
