#ifndef COMPACT_INTERVAL_STABBING_NEW_H
#define	COMPACT_INTERVAL_STABBING_NEW_H

#include "interval_stabbing.h"
#include "static_bitsequence_brw32.h"
#include "tree_ff.h"
#include "upper_coordinates.h"
#include "../util/coordinates_encoding/coordinates_storage.h"
#include "../util/coordinates_encoding/encoder.h"

class compact_interval_stabbing_new : public interval_stabbing {
  public:
	compact_interval_stabbing_new(interval *intervals, uint size, uint lowerBlockSize, uint upperBlockSize, char *encoder, int scaleFactor);
	~compact_interval_stabbing_new();
	int queryMark(interval *queryInterval, long *result, uint *resultSize, uint *intersector);
	int queryReport(interval *queryInterval, long *result, uint *resultSize, uint *intersector);
	uint memoryUsage();

  private:
	CoordinatesStorage *lowerCoords;
	CoordinatesStorage *upperCoords;
	long *ids;
	tree_ff *tree;
	
	uint *nodesDeque;
	uint ndHead;
};

#endif
