#ifndef ISAAC_INTERVAL_STABBING_H
#define	ISAAC_INTERVAL_STABBING_H

#include "../util/basics.h"
#include "interval_stabbing.h"

//auxiliary
struct isaac_node {
  long id;
  double coord;
  isaac_node *parent;
  isaac_node *leftsibling;
  isaac_node *rightchild;
};

class isaac_interval_stabbing : public interval_stabbing {
  public:
	isaac_interval_stabbing(interval *intervals, uint size);
	~isaac_interval_stabbing();
	int queryMark(interval *queryInterval, long *result, uint *resultSize, uint *intersector);
	int queryReport(interval *queryInterval, long *result, uint *resultSize, uint *intersector);
	uint memoryUsage();

  private:
	double *coords;
	isaac_node *root;
	isaac_node **start;

	isaac_node **nodesDeque;
	uint ndHead;
};

#endif
