#ifndef MAXIMAL_INTERVAL_STABBING_H
#define	MAXIMAL_INTERVAL_STABBING_H

#include "../util/basics.h"
#include "interval_stabbing.h"

#include "../util/coordinates_encoding/coordinates_storage.h"
#include "../util/coordinates_encoding/encoder.h"


class maximal_interval_stabbing : public interval_stabbing {
  public:
    maximal_interval_stabbing(interval *intervals, uint size, uint lowerBlockSize, uint upperBlockSize, char *encoder, int scaleFactor);
    ~maximal_interval_stabbing();
    int queryMark(interval *queryInterval, long *result, uint *resultSize, uint *intersector);
    int queryReport(interval *queryInterval, long *result, uint *resultSize, uint *intersector);
    uint memoryUsage();
    
  private:
    CoordinatesStorage **lowerCoords;
    CoordinatesStorage **upperCoords;
    long **ids;
    uint numMaxSets;
};

#endif
