#ifndef MAXIMAL_INTERVAL_STABBING_NEW_H
#define MAXIMAL_INTERVAL_STABBING_NEW_H

#include <Sequence.h>

#include "interval_stabbing.h"
#include "mbr.h"

#include "../util/coordinates_encoding/coordinates_storage.h"
#include "../util/coordinates_encoding/encoder.h"

using namespace std;

class maximal_interval_stabbing_new {
  public:
    maximal_interval_stabbing_new(interval *intervals, uint size, uint lowerBlockSize, uint upperBlockSize, char *encoder, int scaleFactor);
    ~maximal_interval_stabbing_new();
    int queryMark(interval *queryInterval, long *result, uint *resultSize, uint *intersector);
    int queryReport(interval *queryInterval, long *result, uint *resultSize, uint *intersector);
    uint memoryUsage();
    
  private:
    uint n;
    CoordinatesStorage **lowerCoords;
    CoordinatesStorage *upperCoords;
    long **ids;
    uint numMaxSets;
    cds_static::WaveletTree *maximalSeqWT;
    
};

struct s_coord {
	double coord;
	long id;
};
typedef struct s_coord COORD;
int cmpcoords(const void * c1, const void * c2) {
  double result = ((COORD *) c1)->coord - ((COORD *) c2)->coord;
  if(result > 0) {
    return 1;
  } else if(result < 0) {
    return -1;
  } else {
    return 0;
  }
}

#endif
