#ifndef MBR_RANGE_H
#define	MBR_RANGE_H

#include "interval_stabbing.h"
#include "mbr.h"

#define COMPACT 1
#define NO_COMPACT 2
#define COMPACT_NEW 3
#define COMPACT_NEW_R 4
#define MAXIMAL 5

class mbr_range {
  public:
    mbr_range(mbr *mbrs, uint size, uint type, uint lowerBlockSize = 0, uint upperBlockSize = 0, char *encoder = NULL, int scaleFactor = 0);
    ~mbr_range();
    int query(mbr *queryMBR, long *result, uint *resultSize);
    uint memoryUsage();
    
  private:
    interval_stabbing *x_intervals;
    interval_stabbing *y_intervals;
    uint *intersector;
    uint intersectorSize;
    
    void cleanIntersector() {
      for(int i = 0; i < intersectorSize; i++) {
	intersector[i] = 0;
      }
    }
};

#endif
