#include "./upper_coordinates.h"

UpperCoordinates::UpperCoordinates(double *list, uint _listLength, int _scaleFactor) {
  listLength = _listLength; 
  scaleFactor = _scaleFactor;
  minVal = list[0];
  double maxVal = 0;
  uint cValue;
  
  for(uint i = 1; i < _listLength; i++) {
    if(list[i] < minVal) 
      minVal = list[i];
    if(list[i] > maxVal)
      maxVal = list[i];
  }
  
  numBits = bits((uint)round((maxVal-minVal)*scaleFactor));
  
  values = new uint[(listLength*numBits+W-1)/W];
  
  int pos = 0;
  for(uint i = 0; i < _listLength; i++) {
    cValue = (uint)round((list[i]-minVal)*scaleFactor);
    bitwrite(values, pos, numBits, cValue);
    pos += numBits;
  }
}

UpperCoordinates::~UpperCoordinates() {
  delete [] values;
}

uint UpperCoordinates::memoryUsage() const {
  return sizeof(*this)
  + sizeof(uint)*(listLength*numBits+W-1)/W;
}


//return the value at pos
double UpperCoordinates::access(uint pos) const {
  return minVal+(1.0*bitread(values, pos*numBits, numBits))/scaleFactor;
}
